#include "msg.h"

/****************************************************************************
*                                UWM_SET_RANGE
* Inputs:
*       WPARAM: (WPARAM)(int) lower bound
*       LPARAM: (LPARAM)(int) upper bound
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sets the range in the multipanel
****************************************************************************/

DECLARE_MESSAGE(UWM_SET_RANGE)


/****************************************************************************
*                               UWM_THREAD_INFO
* Inputs:
*       WPARAM: (WPARAM)(int) thread number
*       LPARAM: (LPARAM)(int) value
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Tells the current position in thread n
****************************************************************************/

DECLARE_MESSAGE(UWM_THREAD_INFO)


/****************************************************************************
*                             UWM_THREAD_FINISHED
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Marks the thread as finished
****************************************************************************/

DECLARE_MESSAGE(UWM_THREAD_FINISHED)


/****************************************************************************
*                             UWM_SET_THREADCOUNT
* Inputs:
*       WPARAM:(WPARAM)(int) thread count
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sets the number of segments
****************************************************************************/

DECLARE_MESSAGE(UWM_SET_THREADCOUNT)


/****************************************************************************
*                                  UWM_TIME
* Inputs:
*       WPARAM: (WPARAM)(CString *) string value to set
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Shows the runtime
****************************************************************************/

DECLARE_MESSAGE(UWM_TIME)


/****************************************************************************
*                                UWM_PLOTTIME
* Inputs:
*       WPARAM: (WPARAM)(double *) time value
*       LPARAM: (LPARAM)(int) threadcount
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Plots the x=nthreads y= time plot
****************************************************************************/

DECLARE_MESSAGE(UWM_PLOTTIME)

/****************************************************************************
*                                  UWM_TICK
* Inputs:
*       WPARAM: (WPARAM)(int) thread id, -1 for master thread
*       LPARAM: (LPARAM)(DWORD) time value
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Records a tick
****************************************************************************/

DECLARE_MESSAGE(UWM_TICK)

/****************************************************************************
*                                UWM_RUN_UNTIL
* Inputs:
*       WPARAM: (WPARAM)(int) Current loop iteration
*       LARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Posts the current iteration value
****************************************************************************/

DECLARE_MESSAGE(UWM_RUN_UNTIL)
