// openmpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "openmpDlg.h"
#include "omp.h"
#include <afxpriv.h>
#include "Messages.h"
#include "ToClip.h"

//#define _TRACE
#include "IteratorLimit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define IDT_IGNORE 1


/****************************************************************************
*                                  CAboutDlg
****************************************************************************/

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


/****************************************************************************
*                           CopenmpDlg::CopenmpDlg
* Inputs:
*       CWnd * pParent: Parent window
* Effect: 
*       Constructor
****************************************************************************/

CopenmpDlg::CopenmpDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CopenmpDlg::IDD, pParent)
{
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
        initialized = FALSE;
        queue = NULL;
        running = FALSE;
}

/****************************************************************************
*                         CopenmpDlg::DoDataExchange
* Inputs:
*       CDataExchnage * pDX:
* Result: void
*       
* Effect: 
*       Binds controls
****************************************************************************/

void CopenmpDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        DDX_Control(pDX, IDC_RUN_UNTIL_COUNT, c_RunUntilCount);
        DDX_Control(pDX, IDC_OMP_SET_NUM_THREADS_PAREN, c_omp_set_num_threads_paren);
        DDX_Control(pDX, IDC_SPIN, c_Spin);
        DDX_Control(pDX, IDC_SLEEP, c_Sleep);
        DDX_Control(pDX, IDC_FRAME, c_Frame);
        DDX_Control(pDX, IDC_COPY_GRAPH, c_CopyGraph);
        DDX_Control(pDX, IDC_WORK, c_Work);
        DDX_Control(pDX, IDC_TEN, c_Ten);
        DDX_Control(pDX, IDC_SPIN_WORK, c_SpinWork);
        DDX_Control(pDX, IDC_CLEARTIMES, c_ClearTimes);
        DDX_Control(pDX, IDC_HIPRI, c_GUIHiPri);
        DDX_Control(pDX, IDC_CPUS, c_CPUs);
        DDX_Control(pDX, IDC_COPY, c_CopyCode);
        DDX_Control(pDX, IDC_SPIN_THREADS, c_SpinNumThreads);
        DDX_Control(pDX, IDC_THREADS, c_NumThreads);
        DDX_Control(pDX, IDC_OMP_SET_NUM_THREADS, c_omp_set_num_threads);
        DDX_Control(pDX, IDC_PLOT, c_Plot);
        DDX_Control(pDX, IDC_TIME,c_Time);
        DDX_Control(pDX, IDC_GETENV, c_GetEnv);
        DDX_Control(pDX, IDC_ENVIRONMENT, c_Environment);
        DDX_Control(pDX, IDC_ENVIRONMENT_CAPTION, x_Environment);
        DDX_Control(pDX, IDC_PROGRESS, c_Progress);
        DDX_Control(pDX, IDC_RUN, c_Run);
        DDX_Control(pDX, IDC_SCHEDULE_STATIC, c_ScheduleStatic);
        DDX_Control(pDX, IDC_SCHEDULE_DYNAMIC, c_ScheduleDynamic);
        DDX_Control(pDX, IDC_SCHEDULE_GUIDED, c_ScheduleGuided);
        DDX_Control(pDX, IDC_SCHEDULE_RUNTIME, c_ScheduleRuntime);
        DDX_Control(pDX, IDC_SPINCHUNK, c_SpinChunk);
        DDX_Control(pDX, IDC_CHUNK, c_Chunk);
        DDX_Control(pDX, IDC_CODE, c_Code);
        DDX_Control(pDX, IDC_USECHUNK, c_UseChunk);
        DDX_Control(pDX, IDC_OMP_SET_DYNAMIC, c_omp_set_dynamic);
        DDX_Control(pDX, IDC_SECTIONS, c_Sections);
        DDX_Control(pDX, IDC_NOWAIT, c_NoWait);
        DDX_Control(pDX, IDC_PARALLEL_FOR_CAPTION, x_ParallelFor);
        DDX_Control(pDX, IDC_ATOMIC_TESTS_CAPTION, x_AtomicTests);
        DDX_Control(pDX, IDC_PARALLEL_SECTIONS_CAPTION, x_ParallelSections);
        DDX_Control(pDX, IDC_PARALLEL_FOR_ENABLE, c_ParallelForEnable);
        DDX_Control(pDX, IDC_ATOMIC_TESTS_ENABLE, c_AtomicTestsEnable);
        DDX_Control(pDX, IDC_PARALLEL_SECTIONS_ENABLE, c_ParallelSectionsEnable);
        DDX_Control(pDX, IDC_ATOMIC_PLUS, c_AtomicAdd);
        DDX_Control(pDX, IDC_ATOMIC_MULTIPLY, c_AtomicMul);
        DDX_Control(pDX, IDC_RUN_UNTIL, c_RunUntil);
}

/****************************************************************************
*                                 Message Map
****************************************************************************/

BEGIN_MESSAGE_MAP(CopenmpDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()

        ON_MESSAGE(WM_KICKIDLE, OnKickIdle)
        ON_REGISTERED_MESSAGE(UWM_TICK, OnTick)
        ON_REGISTERED_MESSAGE(UWM_RUN_UNTIL, OnRunUntil)
        ON_REGISTERED_MESSAGE(UWM_PLOTTIME, OnTimePlot)
        ON_REGISTERED_MESSAGE(UWM_TIME, OnTime)
        ON_REGISTERED_MESSAGE(UWM_SET_RANGE, OnSetRange)
        ON_REGISTERED_MESSAGE(UWM_THREAD_FINISHED, OnThreadFinished)
        ON_REGISTERED_MESSAGE(UWM_THREAD_INFO, OnThreadInfo)
        ON_REGISTERED_MESSAGE(UWM_SET_THREADCOUNT, OnThreadCount)
    ON_WM_CLOSE()
   
    ON_BN_CLICKED(IDC_COPY, &CopenmpDlg::OnBnClickedCopy)
    ON_BN_CLICKED(IDC_RUN, &CopenmpDlg::OnBnClickedRun)
    ON_BN_CLICKED(IDC_OMP_SET_NUM_THREADS, OnBnClickedompsetnumthreads)
    ON_BN_CLICKED(IDC_SCHEDULE_STATIC, &CopenmpDlg::OnBnClickedScheduleStatic)
    ON_BN_CLICKED(IDC_SCHEDULE_DYNAMIC, &CopenmpDlg::OnBnClickedScheduleDynamic)
    ON_BN_CLICKED(IDC_SCHEDULE_GUIDED, &CopenmpDlg::OnBnClickedScheduleGuided)
    ON_BN_CLICKED(IDC_SCHEDULE_RUNTIME, &CopenmpDlg::OnBnClickedScheduleRuntime)
    ON_BN_CLICKED(IDC_USECHUNK, &CopenmpDlg::OnBnClickedUseChunk)
    ON_EN_CHANGE(IDC_CHUNK, &CopenmpDlg::OnEnChangeChunk)
    ON_EN_CHANGE(IDC_ENVIRONMENT, &CopenmpDlg::OnEnChangeEnvironment)
    ON_EN_CHANGE(IDC_THREADS, &CopenmpDlg::OnEnChangeThreads)
    ON_WM_SIZE()
    ON_BN_CLICKED(IDC_CLEARTIMES, &CopenmpDlg::OnBnClickedCleartimes)
    ON_BN_CLICKED(IDC_ATOMIC_PLUS, &CopenmpDlg::OnBnClickedAtomicPlus)
    ON_BN_CLICKED(IDC_ATOMIC_MULTIPLY, &CopenmpDlg::OnBnClickedAtomicMultiply)
    ON_BN_CLICKED(IDC_SECTIONS, &CopenmpDlg::OnBnClickedSections)
    ON_BN_CLICKED(IDC_PARALLEL_FOR_ENABLE, &CopenmpDlg::OnBnClickedParallelForEnable)
    ON_BN_CLICKED(IDC_ATOMIC_TESTS_ENABLE, &CopenmpDlg::OnBnClickedAtomicTestsEnable)
    ON_BN_CLICKED(IDC_PARALLEL_SECTIONS_ENABLE, &CopenmpDlg::OnBnClickedParallelSectionsEnable)
    ON_BN_CLICKED(IDC_NOWAIT, &CopenmpDlg::OnBnClickedNowait)
    ON_BN_CLICKED(IDC_COPY_GRAPH, &CopenmpDlg::OnBnClickedCopyGraph)
    ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()


// CopenmpDlg message handlers

/****************************************************************************
*                          CopenmpDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the dialog
****************************************************************************/

BOOL CopenmpDlg::OnInitDialog()
{
        CDialog::OnInitDialog();

        // Add "About..." menu item to system menu.

        // IDM_ABOUTBOX must be in the system command range.
        ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
        ASSERT(IDM_ABOUTBOX < 0xF000);

        CMenu* pSysMenu = GetSystemMenu(FALSE);
        if (pSysMenu != NULL)
        {
                CString strAboutMenu;
                strAboutMenu.LoadString(IDS_ABOUTBOX);
                if (!strAboutMenu.IsEmpty())
                {
                        pSysMenu->AppendMenu(MF_SEPARATOR);
                        pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
                }
        }

        // Set the icon for this dialog.  The framework does this automatically
        //  when the application's main window is not a dialog
        SetIcon(m_hIcon, TRUE);                 // Set big icon
        SetIcon(m_hIcon, FALSE);                // Set small icon

        //****************************************************************
        // System setup
        //****************************************************************
        queue = ::CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0);
        SetTimer(IDT_IGNORE, 20, NULL);

        //****************************************************************
        // Parallel For
        //****************************************************************
        CheckRadioButton(IDC_SCHEDULE_STATIC, IDC_SCHEDULE_RUNTIME, IDC_SCHEDULE_STATIC);

        c_omp_set_dynamic.SetCheck(omp_get_dynamic() ? BST_CHECKED : BST_UNCHECKED);

        c_SpinChunk.SetRange(0, 100);
        c_SpinChunk.SetPos(0);
        
        //****************************************************************
        // parallel section
        //****************************************************************
        CheckRadioButton(IDC_SLEEP, IDC_SPIN, IDC_SLEEP);
        
        //****************************************************************
        // Generic setup
        //****************************************************************
        c_SpinNumThreads.SetRange(1, 100);
        c_SpinNumThreads.SetPos(1);


        defaultthreads = omp_get_max_threads();

        //----------------------------------------------------------------
        // Display
        //----------------------------------------------------------------
        CBitmap bmp;
        bmp.LoadBitmap(IDB_COPY);
        c_CopyCode.SetBitmap(bmp);
        c_CopyGraph.SetBitmap(bmp);

        bmp.Detach();

        //----------------------------------------------------------------
        // CPU display
        //----------------------------------------------------------------
        { /* CPUS */
         CString s;
         int cpus = omp_get_num_procs();
         s.Format(_T("%d"), cpus);
         c_CPUs.SetWindowText(s);
        } /* CPUS */

        //----------------------------------------------------------------
        // Work controls
        //----------------------------------------------------------------
        { 
         c_SpinWork.SetRange(1, 5);
         c_SpinWork.SetPos(5);
         CFont * f = c_Ten.GetFont();
         ASSERT(f != NULL);
         LOGFONT lf;
         f->GetLogFont(&lf);
         CRect r;
         c_Ten.GetClientRect(&r);
         lf.lfHeight = r.Height() - 2;
         CFont f10;
         f10.CreateFontIndirect(&lf);
         c_Ten.SetFont(&f10);
         f10.Detach();
        }

        //****************************************************************
        // All initialized!
        //****************************************************************
        initialized = TRUE;

        updateControls();

        return TRUE;  // return TRUE  unless you set the focus to a control
} // CopenmpDlg::OnInitDialog

/****************************************************************************
*                          CopenmpDlg::OnSysCommand
* Inputs:
*       UINT nID:
*       LPARAM lParam:
* Result: void
*       
* Effect: 
*       Handles system menu
****************************************************************************/

void CopenmpDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CopenmpDlg::OnPaint()
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CopenmpDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}


/****************************************************************************
*                              CopenmpDlg::OnOK
* Result: void
*       
* Effect: 
*       Does nothing.  Avoids having <enter> key exit the program
****************************************************************************/

void CopenmpDlg::OnOK()
    {
    }

/****************************************************************************
*                            CopenmpDlg::OnCancel
* Result: void
*       
* Effect: 
*       Does nothing.  Prevents <escape> key from closing application
****************************************************************************/

void CopenmpDlg::OnCancel()
    {
    }

/****************************************************************************
*                             CopenmpDlg::OnClose
* Result: void
*       
* Effect: 
*       Closes the application
****************************************************************************/

void CopenmpDlg::OnClose()
    {
     CDialog::OnOK();
    }


/****************************************************************************
*                         CopenmpDlg::OnBnClickedRun
* Result: void
*       
* Effect: 
*       Starts the run-thread
****************************************************************************/

void CopenmpDlg::OnBnClickedRun()
    {

     TRACE("%08x: Resetting segments\n", ::GetCurrentThreadId());

     c_Progress.ShowWindow(SW_SHOW);
     c_Progress.SetSegments(0);

     ThreadPrep();
     AfxBeginThread(parallelfor, this);
     if(c_GUIHiPri.GetCheck() == BST_CHECKED)
        ::SetThreadPriority(::GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);
     updateControls();
    }

/****************************************************************************
*                           CopenmpDlg::ThreadPrep
* Result: void
*       
* Effect: 
*       Sets up the per-thread parameters
*               numthreads
****************************************************************************/

void CopenmpDlg::ThreadPrep()
    {
     numthreads = c_SpinNumThreads.GetPos32();
     UseNumThreads = c_omp_set_num_threads.GetCheck() == BST_CHECKED;
     running = TRUE;
     setdynamic = c_omp_set_dynamic.GetCheck() == BST_CHECKED;
     work = 10;
     int power = c_SpinWork.GetPos32();
     for(int i = 1; i < power; i++)
        work *= 10;

     RunUntil = FALSE;
     if(UseNumThreads)
        RunUntil = c_RunUntil.GetCheck() == BST_CHECKED;

     c_RunUntilCount.SetWindowText(_T(""));
     c_RunUntilCount.ShowWindow(RunUntil ? SW_SHOW : SW_HIDE);

    } // CopenmpDlg::ThreadPrep

/****************************************************************************
*                             CopenmpDlg::parallelfor
* Inputs:
*       LPVOID p: (LPVOID)(CopenmpDlg *)
* Result: UINT
*       0, always
* Effect: 
*       Transfers from C to C++ space
****************************************************************************/

/* static */ UINT CopenmpDlg::parallelfor(LPVOID p)
   {
    CopenmpDlg * self = (CopenmpDlg*)p;
    self->parallelfor();
    return 0;
   } // CopenmpDlg::parallelfor

/****************************************************************************
*                             CopenmpDlg::parallelfor
* Result: void
*       
* Effect: 
*       Runs the thread
****************************************************************************/

void CopenmpDlg::parallelfor()
   {
    const int limit = ITERATOR_LIMIT;
#ifdef _TRACE
    TRACE("%08x: -----------------thread starting---------------------\n", ::GetCurrentThreadId());
    TRACE("%08x: Sending UWM_SET_RANGE(%d, %d)\n", ::GetCurrentThreadId(), 0, limit);
#endif

    QueueMessage(m_hWnd, UWM_SET_RANGE, 0, limit);

    times.SetSize(limit);

    int nthreads = InitOMPParameters();
    if(RunUntil)
       for(int i = 1; i <= nthreads; i++)
          { /* run full plot */
           QueueMessage(m_hWnd, UWM_RUN_UNTIL, (WPARAM)i);
           omp_set_num_threads(i);
           DoForAllLoop(i);
          } /* run full plot */
    else
       DoForAllLoop(nthreads);
    
#ifdef _TRACE
    TRACE("%08x -----------------thread finished---------------------\n", ::GetCurrentThreadId());
    TRACE("%08X: Sending UWM_THREAD_FINISHED()\n", ::GetCurrentThreadId());
#endif
    QueueMessage(m_hWnd, UWM_THREAD_FINISHED);
   } // CopenmpDlg::paralelfor


/****************************************************************************
*                    CopenmpDlg::OnBnClickedScheduleStatic
* Result: void
*       
* Effect: 
*       forces control update
****************************************************************************/

void CopenmpDlg::OnBnClickedScheduleStatic()
    {
     updateControls();
    }

/****************************************************************************
*                   CopenmpDlg::OnBnClickedScheduleDynamic
* Result: void
*       
* Effect: 
*       forces control update
****************************************************************************/

void CopenmpDlg::OnBnClickedScheduleDynamic()
    {
     updateControls();
    }

/****************************************************************************
*                    CopenmpDlg::OnBnClickedScheduleGuided
* Result: void
*       
* Effect: 
*       forces control update
****************************************************************************/

void CopenmpDlg::OnBnClickedScheduleGuided()
    {
     updateControls();
    }

/****************************************************************************
*                   CopenmpDlg::OnBnClickedScheduleRuntime
* Result: void
*       
* Effect: 
*       forces control update
****************************************************************************/

void CopenmpDlg::OnBnClickedScheduleRuntime()
    {
     updateControls();
    }

/****************************************************************************
*                       CopenmpDlg::OnBnClickedUseChunk
* Result: void
*       
* Effect: 
*       forces control update
****************************************************************************/

void CopenmpDlg::OnBnClickedUseChunk()
    {
     updateControls();
    }

/****************************************************************************
*                         CopenmpDlg::OnEnChangeChunk
* Result: void
*       
* Effect: 
*       forces control update
****************************************************************************/

void CopenmpDlg::OnEnChangeChunk()
    {
     updateControls();
    }

/****************************************************************************
*                      CopenmpDlg::OnEnChangeEnvironment
* Result: void
*       
* Effect: 
*       forces control update
****************************************************************************/

void CopenmpDlg::OnEnChangeEnvironment()
    {
     updateControls();
    }

/****************************************************************************
*                         CopenmpDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CopenmpDlg::updateControls()
    {
     if(!initialized)
        return;
     
     //****************************************************************
     // Generic setup
     //****************************************************************
     CString code = _T("");
     
     c_GUIHiPri.EnableWindow(!running);
     c_SpinWork.EnableWindow(!running);
     c_omp_set_num_threads.EnableWindow(!running);
     c_omp_set_num_threads_paren.EnableWindow(!running);

     BOOL enablethreads;
     enablethreads = c_omp_set_num_threads.GetCheck() == BST_CHECKED;
     c_SpinNumThreads.EnableWindow(enablethreads && !running);
     c_NumThreads.EnableWindow(enablethreads && !running);

     c_RunUntil.EnableWindow(enablethreads && !running);

     c_ClearTimes.EnableWindow(!running);
     c_omp_set_dynamic.EnableWindow(!running);

     //****************************************************************
     // Parallel For
     //****************************************************************

     BOOL ParallelForEnable = (c_ParallelForEnable.GetCheck() == BST_CHECKED);

     x_ParallelFor.EnableWindow(ParallelForEnable);

     CString schedule;
     BOOL chunkenable = FALSE;
     BOOL enableomp = FALSE;
     
     c_ScheduleStatic.EnableWindow(!running && ParallelForEnable);
     c_ScheduleDynamic.EnableWindow(!running && ParallelForEnable);
     c_ScheduleGuided.EnableWindow(!running && ParallelForEnable);
     c_ScheduleRuntime.EnableWindow(!running && ParallelForEnable);


     if(c_ScheduleStatic.GetCheck() == BST_CHECKED)
        { /* static */
         schedule = _T("static");
         chunkenable = TRUE;
        } /* static */
     else
     if(c_ScheduleDynamic.GetCheck() == BST_CHECKED)
        { /* dynamic */
         schedule = _T("dynamic");
         chunkenable = TRUE;
        } /* dynamic */
     else
     if(c_ScheduleGuided.GetCheck() == BST_CHECKED)
        { /* guided */
         schedule = _T("guided");
         chunkenable = TRUE;
        } /* guided */
     else
     if(c_ScheduleRuntime.GetCheck() == BST_CHECKED)
        { /* runtime */
         schedule = _T("runtime");
         chunkenable = FALSE;
         enableomp = TRUE;
        } /* runtime */
     
     c_UseChunk.EnableWindow(chunkenable &&  !running && ParallelForEnable);
     c_Chunk.EnableWindow(chunkenable &&     !running && c_UseChunk.GetCheck() == BST_CHECKED && ParallelForEnable);
     c_SpinChunk.EnableWindow(chunkenable && !running && c_UseChunk.GetCheck() == BST_CHECKED && ParallelForEnable);

     c_Environment.EnableWindow(enableomp && !running && ParallelForEnable);
     x_Environment.EnableWindow(enableomp && !running && ParallelForEnable);


     //----------------------------------------------------------------
     // Parallel For code
     //----------------------------------------------------------------
     BOOL runnable = FALSE;
     
     if(ParallelForEnable)
        { /* parallel for code */
         code = _T("#pragma omp parallel for schedule(");
         code += schedule;
         CString runtime = schedule;

         if(chunkenable && c_UseChunk.GetCheck() == BST_CHECKED)
            { /* chunkable */
             int chunks = c_SpinChunk.GetPos32();
             if(chunks > 0)
                { /* use chunks */
                 CString s;
                 s.Format(_T(",%d"), chunks);
                 code += s;
                 runtime += s;
                } /* use chunks */
            } /* chunkable */
         code += _T(")");

         if(c_omp_set_num_threads.GetCheck() == BST_CHECKED)
            { /* set threads */
             CString s;
             s.Format(_T(" num_threads(%d)"), c_SpinNumThreads.GetPos32());
             code += s;
            } /* set threads */

         code += _T("\r\nfor(int i=0; i < limit; i++)\r\n   {\r\n   }");

         CString env;
         c_Environment.GetWindowText(env);
         env.Trim();
         runnable = chunkenable || !env.IsEmpty();

         if(enableomp)
            { /* use environment */
             ::SetEnvironmentVariable(_T("OMP_SCHEDULE"), env);
            } /* use environment */
         else
            { /* compute environment */
             ::SetEnvironmentVariable(_T("OMP_SCHEDULE"), runtime);
            } /* compute environment */
        } /* parallel for code */

     c_Run.EnableWindow(runnable && !running && ParallelForEnable);

     //----------------------------------------------------------------
     // Show the environment variable
     //----------------------------------------------------------------
     CString ev;
#define MAX_ENV 1024
     LPTSTR p = ev.GetBuffer(MAX_ENV);
     ::GetEnvironmentVariable(_T("OMP_SCHEDULE"), p, MAX_ENV);
     ev.ReleaseBuffer();
     ev = _T("OMP_SCHEDULE=") + ev;
     CString old;
     c_GetEnv.GetWindowText(old);
     if(old != ev)
        c_GetEnv.SetWindowText(ev);

     c_GetEnv.EnableWindow(ParallelForEnable);
     
     //****************************************************************
     // Atomic tests
     //****************************************************************

     BOOL AtomicTestsEnable = c_AtomicTestsEnable.GetCheck() == BST_CHECKED;
     x_AtomicTests.EnableWindow(!running && AtomicTestsEnable);
     c_AtomicAdd.EnableWindow(!running && AtomicTestsEnable);
     c_AtomicMul.EnableWindow(!running && AtomicTestsEnable);
     //----------------------------------------------------------------
     // Atomic tests code
     //----------------------------------------------------------------
     if(AtomicTestsEnable)
        { /* atomic code */
         code = _T("pragma omp atomic\r\n");
         code += _T("lvalue op= expr;");
        } /* atomic code */

     //****************************************************************
     // Parallel Sections
     //****************************************************************

     BOOL ParallelSectionsEnable = c_ParallelSectionsEnable.GetCheck() == BST_CHECKED;
     x_ParallelSections.EnableWindow(!running && ParallelSectionsEnable);
     c_NoWait.EnableWindow(!running && ParallelSectionsEnable);
     c_Sections.EnableWindow(!running && ParallelSectionsEnable);
     c_Spin.EnableWindow(!running && ParallelSectionsEnable);
     c_Sleep.EnableWindow(!running && ParallelSectionsEnable);
     //----------------------------------------------------------------
     // Parallel Sections code
     //----------------------------------------------------------------
     if(ParallelSectionsEnable)
        { /* parallel sections code */
         code = _T("#pragma omp parallel sections");
         if(c_NoWait.GetCheck() == BST_CHECKED)
            code += _T(" nowait");

         code += _T("\r\n{\r\n");
         for(int i = 0; i < 3; i++)
            { /* sections */
             code += _T("#pragma omp section\r\n  {\r\n   structured block\r\n  }\r\n");
            } /* sections */
         code += _T("}");
        } /* parallel sections code */

     //****************************************************************
     // Show code
     //****************************************************************

     c_Code.SetWindowText(code);

    } // CopenmpDlg::updateControls

/****************************************************************************
*                          CopenmpDlg::QueueMessage
* Inputs:
*       HWND hWnd: window to notify
*       UINT message: message to send
*       WPARAM: first parameter
*       LPARAM: second parameter
* Result: void
*       
* Effect: 
*       Queues the message
****************************************************************************/

void CopenmpDlg::QueueMessage(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
    {
     ASSERT(queue != NULL);
     PMSG msg = new MSG;
     msg->hwnd = hWnd;
     msg->message = message;
     msg->wParam = wParam;
     msg->lParam = lParam;
     ::PostQueuedCompletionStatus(queue,
                                  0, // number of bytes transferred
                                  0, // completion key
                                  (LPOVERLAPPED)msg);
    } // CopenmpDlg::QueueMessage

/****************************************************************************
*                           CopenmpDlg::OnKickIdle
* Inputs:
*       WPARAM: MSGF_DIALOGBOX
*       LPARAM: idle count
* Result: LRESULT
*       (LRESULT)(BOOL) TRUE to keep polling, FALSE to stop polling
* Effect: 
*       Dequeues queued messages
****************************************************************************/

LRESULT CopenmpDlg::OnKickIdle(WPARAM wParam, LPARAM lParam)
    {
     if(queue == NULL)
        return FALSE;
     
     PMSG msg;
     DWORD bytes; // byte count (ignored)
     ULONG_PTR key;

#define DEQUEUE_LIMIT 10 // no more than this many messages per idle hit
     for(int i = 0; i < DEQUEUE_LIMIT; i++)
        { /* dequeue */
         BOOL b = ::GetQueuedCompletionStatus(queue, &bytes, &key, (LPOVERLAPPED *)&msg, 0);
         if(!b)
            { /* error */
             return FALSE; // assume for now: queue is empty
            } /* error */
         ::PostMessage(msg->hwnd, msg->message, msg->wParam, msg->lParam);
         delete msg;
        } /* dequeue */
     return FALSE; // queue is at limit; wait for next kick-idle
    } // CopenmpDlg::OnKickIdle

/****************************************************************************
*                           CopenmpDlg::OnSetRange
* Inputs:
*       WPARAM: (WPARAM)(int) lower bound
*       LPARAM: (LPARAM)(int) upper bound
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sets the limit on the multiscrollbar
****************************************************************************/

LRESULT CopenmpDlg::OnSetRange(WPARAM wParam, LPARAM lParam)
    {
#ifdef _TRACE
     TRACE("%08x: Handled UWM_SET_RANGE(%d, %d)\n", ::GetCurrentThreadId(), (int)wParam, (int)lParam);
#endif
     c_Progress.SetRange((int)wParam, (int)lParam);
     return 0;
    } // CopenmpDlg::OnSetRange

/****************************************************************************
*                        CopenmpDlg::OnThreadFinished
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULt
*       Logically void, 0, always
* Effect: 
*       Marks the thread as finished
****************************************************************************/

LRESULT  CopenmpDlg::OnThreadFinished(WPARAM, LPARAM)
    {
#ifdef _TRACE
     TRACE("%08x: Handled UWM_THREAD_FINISHED()\n", ::GetCurrentThreadId());
#endif
     running = FALSE;
     if(c_GUIHiPri.GetCheck() == BST_CHECKED)
        ::SetThreadPriority(::GetCurrentThread(), THREAD_PRIORITY_NORMAL);
     updateControls();
     return 0;
    } // CopenmpDlg::OnThreadFinished

/****************************************************************************
*                          CopenmpDlg::OnThreadInfo
* Inputs:
*       WPARAM: (WPARAM)(int) thread number
*       LPARAM: (LPARAM)(int) value
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Updates the position
****************************************************************************/

LRESULT CopenmpDlg::OnThreadInfo(WPARAM wParam, LPARAM lParam)
    {
#ifdef _TRACE
     TRACE("%08x: Handled UWM_THREAD_INFO(%d, %d)\n", ::GetCurrentThreadId(), (int)wParam, (int)lParam);
#endif
     c_Progress.SetPos((int)wParam, (int)lParam);
     return 0;
    } // CopenmpDlg::OnThreadInfo

/****************************************************************************
*                                CopenmpDlg::OnThreadCount
* Inputs:
*       WPARAM: count of threads
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sets the number of display segments
****************************************************************************/

LRESULT CopenmpDlg::OnThreadCount(WPARAM wParam, LPARAM)
    {
#ifdef _TRACE
     TRACE("%08x: Handled UWM_SET_THREADCOUNT(%d)\n", ::GetCurrentThreadId(), (int)wParam);
#endif
     c_Progress.SetSegments((int)wParam);
     
     return 0;
    } // CopenmpDlg::OnThreadCount

/****************************************************************************
*                           CopenmpDlg::OnTimePlot
* Inputs:
*       WPARAM: (WPARAM)(double *) the time to plot
*       LPARAM: (LPARAM)(int) the number of threads
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Plots the time value
****************************************************************************/

LRESULT CopenmpDlg::OnTimePlot(WPARAM wParam, LPARAM lParam)
    {
     double * d = (double *)wParam;
     UINT n = (UINT)lParam;

     c_Plot.AddTime(*d, n);
     delete d;
     return 0;
    } // CopenmpDlg::OnTimePlot

/****************************************************************************
*                             CopenmpDlg::OnTime
* Inputs:
*       WPARAM: (WPARAM)(CString *) time
*       LPARAM: (LPARAM)
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Logs the time
****************************************************************************/

LRESULT CopenmpDlg::OnTime(WPARAM wParam, LPARAM)
    {
     CString * s = (CString *)wParam;
     c_Time.SetWindowText(*s);
     
     delete s;
     return 0;
    } // CopenmpDlg::OnTime

/****************************************************************************
*                           CopenmpDlg::OnRunUntil
* Inputs:
*       WPARAM: (WPARAM)(int) Current iteration
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Posts the current iteration value      
****************************************************************************/

LRESULT CopenmpDlg::OnRunUntil(WPARAM wParam, LPARAM)
    {
     int n = (int)wParam;
     CString s;
     s.Format(_T("%d"), n);
     c_RunUntilCount.SetWindowText(s);
     c_Plot.UpdateWindow();
     return 0;
    } // CopenmpDlg::OnRunUntil

/****************************************************************************
*                   CopenmpDlg::OnBnClickedompsetnumthreads
* Result: void
*       
* Effect: 
*       Updates controls
****************************************************************************/

void CopenmpDlg::OnBnClickedompsetnumthreads()
    {
     updateControls();
    } // CopenmpDlg::OnBnClickedompsetnumthreads

/****************************************************************************
*                        CopenmpDlg::OnEnChangeThreads
* Result: void
*       
* Effect: 
*       Forces a control update
****************************************************************************/

void CopenmpDlg::OnEnChangeThreads()
    {
     updateControls();
    }

/****************************************************************************
*                         CopenmpDlg::OnBnClickedCopy
* Result: void
*       
* Effect: 
*       Copies the clipboard contents
****************************************************************************/

void CopenmpDlg::OnBnClickedCopy()
    {
     c_Code.SetRedraw(FALSE);
     int low;
     int high;
     c_Code.GetSel(low, high);
     c_Code.SetSel(0, -1);
     c_Code.SendMessage(WM_COPY);
     c_Code.SetSel(low, high);
     c_Code.SetRedraw(TRUE);
    } // CopenmpDlg::OnBnClickedCopy

/****************************************************************************
*                             CopenmpDlg::OnSize
* Inputs:
*       UINT nType:
*       int cx: new width
*       int cy: new height
* Result: void
*       
* Effect: 
*       Handles the resizing of all controls
****************************************************************************/

void CopenmpDlg::OnSize(UINT nType, int cx, int cy)
    {
     CDialog::OnSize(nType, cx, cy);
    
//     TRACE("OnSize[1](%d, %d, %d)\n", nType, cx, cy);
     CRect r;
     GetClientRect(&r);
     cx = r.Width();
     cy = r.Height();
//     TRACE("OnSize[2](%d, %d, %d)\n", nType, cx, cy);
     

     if(c_Code.GetSafeHwnd() != NULL &&
        c_Plot.GetSafeHwnd() != NULL &&
        c_Progress.GetSafeHwnd() != NULL)
        { /* resize windows */
         //----------------------------------------------------------------
         // Progress window
         //----------------------------------------------------------------
         CRect progress;
         c_Progress.GetWindowRect(&progress);
         ScreenToClient(&progress);
//         TRACE("Progress(L %d, T %d, R %d, B %d) w %d h %d\n", progress.left, progress.top, progress.right, progress.bottom, progress.Width(), progress.Height());

         c_Progress.SetWindowPos(NULL, 0, 0, cx - progress.left, progress.Height(), SWP_NOMOVE | SWP_NOZORDER);
#ifdef _DEBUG
//         CRect progress2;
//         c_Progress.GetWindowRect(&progress2);
//         ScreenToClient(&progress2);
//         TRACE("Progress2(L %d, T %d, R %d, B %d) w %d h %d\n", progress2.left, progress2.top, progress2.right, progress2.bottom, progress2.Width(), progress2.Height());
#endif
         c_Progress.Invalidate();


         //----------------------------------------------------------------
         // Code window
         //----------------------------------------------------------------
         CRect code;
         c_Code.GetWindowRect(&code);
         ScreenToClient(&code);
//         TRACE("Code(L %d, T %d, R %d, B %d) w %d h %d\n", code.left, code.top, code.right, code.bottom, code.Width(), code.Height());

         c_Code.SetWindowPos(NULL, code.left, cy - code.Height(), cx - code.left, code.Height(), SWP_NOZORDER);

         // Now get the new bounding rectangle
         CRect code2;
         c_Code.GetWindowRect(&code2);
         ScreenToClient(&code2);

//         TRACE("Code2(L %d, T %d, R %d, B %d) w %d h %d\n", code2.left, code2.top, code2.right, code2.bottom, code2.Width(), code2.Height());

         c_Code.Invalidate();

         //----------------------------------------------------------------
         // Copy button
         //----------------------------------------------------------------
         CRect copy;
         c_CopyCode.GetWindowRect(&copy);
         ScreenToClient(&copy);
         c_CopyCode.SetWindowPos(NULL, copy.left, code2.top, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
         
         //----------------------------------------------------------------
         // Plot window
         //----------------------------------------------------------------
         CRect plot;
         c_Plot.GetWindowRect(&plot);
         ScreenToClient(&plot);
//         TRACE("Plot(L %d, T %d, R %d, B %d) w %d h %d\n", plot.left, plot.top, plot.right, plot.bottom, plot.Width(), plot.Height());

         int gap = plot.top - progress.bottom;
         c_Plot.SetWindowPos(NULL, 0,0, cx - plot.left, code2.top - plot.top - gap, SWP_NOMOVE | SWP_NOZORDER);

#ifdef _DEBUG
//         CRect plot2;
//         c_Plot.GetWindowRect(&plot2);
//         ScreenToClient(&plot2);
//         TRACE("Plot2(L %d, T %d, R %d, B %d) w %d h %d\n", plot2.left, plot2.top, plot2.right, plot2.bottom, plot2.Width(), plot2.Height());
#endif
         c_Plot.Invalidate();
        } /* resize windows */
    }

/****************************************************************************
*                      CopenmpDlg::OnBnClickedCleartimes
* Result: void
*       
* Effect: 
*       Clears the times plot
****************************************************************************/

void CopenmpDlg::OnBnClickedCleartimes()
    {
     c_Plot.ClearTimes();
    }

void CopenmpDlg::OnBnClickedAtomicPlus()
    {
#pragma omp atomic
     testvalue++;
    }

void CopenmpDlg::OnBnClickedAtomicMultiply()
    {
#pragma omp atomic
     testvalue *= testoperand;
    }

/****************************************************************************
*                       CopenmpDlg::OnBnClickedSections
* Result: void
*       
* Effect: 
*       Shows parallel sections
****************************************************************************/

void CopenmpDlg::OnBnClickedSections()
    {
     c_Plot.ClearTicks();
     ThreadPrep();
     
     delay = 250; // TODO: set this from a control
     running = TRUE;
     startTime = ::GetTickCount();
     NoWait = c_NoWait.GetCheck() == BST_CHECKED;

     if(c_Spin.GetCheck() == BST_CHECKED)
        WaitType = IDC_SPIN;
     else
     if(c_Sleep.GetCheck() == BST_CHECKED)
        WaitType = IDC_SLEEP;
     
     AfxBeginThread(sections, this);
     updateControls();
    }

/****************************************************************************
*                            CopenmpDlg::sections
* Result: void
*       
* Effect: 
*       Handles the sections
****************************************************************************/

void CopenmpDlg::sections()
    {
     int nthreads = InitOMPParameters();
     if(RunUntil)
        for(int i = 1; i <= nthreads; i++)
           { /* run full plot */
            QueueMessage(m_hWnd, UWM_RUN_UNTIL, (WPARAM)i);
            omp_set_num_threads(i);
            DoSectionLoop(i);
           } /* run full plot */
     else
        DoSectionLoop(nthreads);
     
     QueueMessage(m_hWnd, UWM_THREAD_FINISHED);
    } // CopenmpDlg::sections

/****************************************************************************
*                            CopenmpDlg::sections
* Inputs:
*       LPVOID p: (LPVOID)(CopenmpDlg *)
* Result: UINT
*       irrelevant, 0, always
* Effect: 
*       Runs the sections example
****************************************************************************/

/* static */ UINT CopenmpDlg::sections(LPVOID p)
    {
     CopenmpDlg * self = (CopenmpDlg *)p;
     self->sections();
     return 0;
    } // CopenmpDlg::sections

/****************************************************************************
*                             CopenmpDlg::OnTick
* Inputs:
*       WPARAM: (WPARAM) MAKEWPARAM(thread #, section#), (-1, -1) for master thread
*       LPARAM: (LPARAM)(DWORD) time value
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Records a tick
****************************************************************************/

LRESULT CopenmpDlg::OnTick(WPARAM wParam, LPARAM lParam)
    {
     int thread = (int)(short)LOWORD(wParam);
     int section = (int)(short)HIWORD(wParam);
     DWORD t = (DWORD)lParam;
     TRACE("TICK: thread %3d section %d time %6d\n", thread, section, t);
     c_Plot.AddTick(section, thread, t);
     return 0;
    } // CopenmpDlg::OnTick

/****************************************************************************
*                  CopenmpDlg::OnBnClickedParallelForEnable
* Result: void
*       
* Effect: 
*       Forces control update
****************************************************************************/

void CopenmpDlg::OnBnClickedParallelForEnable()
    {
     updateControls();
    }

/****************************************************************************
*                  CopenmpDlg::OnBnClickedAtomicTestsEnable
* Result: void
*       
* Effect: 
*       Forces control update
****************************************************************************/

void CopenmpDlg::OnBnClickedAtomicTestsEnable()
    {
     updateControls();
    }

/****************************************************************************
*                CopenmpDlg::OnBnClickedParallelSectionsEnable
* Result: void
*       
* Effect: 
*       Forces control update
****************************************************************************/

void CopenmpDlg::OnBnClickedParallelSectionsEnable()
    {
     updateControls();
    }

/****************************************************************************
*                        CopenmpDlg::InitOMPParameters
* Result: int
*       Actual number of threads set
* Effect: 
*       Initializes the OMP parameters
****************************************************************************/

int CopenmpDlg::InitOMPParameters()
    {
     int nthreads;
     if(UseNumThreads)
        nthreads = numthreads;
     else
        nthreads = defaultthreads;

     omp_set_num_threads(nthreads);

     omp_set_dynamic(setdynamic);
     return nthreads;
    } // CopenmpDlg::InitOMPParameters

/****************************************************************************
*                          CopenmpDlg::ShowDuration
* Inputs:
*       LARGE_INTEGER duration
* Result: void
*       
* Effect: 
*       Formats the duration and sends it for display
****************************************************************************/

void CopenmpDlg::ShowDuration(LARGE_INTEGER duration)
    {
     LARGE_INTEGER freq;
     ::QueryPerformanceFrequency(&freq);
     
     double time = (double)duration.QuadPart / (double)freq.QuadPart;
     CString * t = new CString;
     if(time < 0.001)
        t->Format(_T("%dus"), (int) (time * 1000000.0));
     else
        if(time < 1.000)
           t->Format(_T("%6.3fms"), time * 1000);
        else
           t->Format(_T("%6.3fs"), time);
     QueueMessage(m_hWnd, UWM_TIME, (WPARAM)t);
    } // CopenmpDlg::ShowDuration

void CopenmpDlg::OnBnClickedNowait()
    {
     updateControls();
    }

/****************************************************************************
*                      CopenmpDlg::OnBnClickedCopyGraph
* Result: void
*       
* Effect: 
*       Copies the graph to the clipboard
****************************************************************************/

void CopenmpDlg::OnBnClickedCopyGraph()
    {
     toClipboard(&c_Plot);
    }

/****************************************************************************
*                         CopenmpDlg::ShowElapsedTime
* Inputs:
*       LARGE_INTEGER duration: The duration of the loop
*       int nthreads: Number of threads
* Result: void
*       
* Effect: 
*       Posts a time plot
****************************************************************************/

void CopenmpDlg::ShowElapsedTime(LARGE_INTEGER duration, int nthreads)
    {
     LARGE_INTEGER freq;
     ::QueryPerformanceFrequency(&freq);

     double time = (double)duration.QuadPart / (double)freq.QuadPart;

     double * d = new double;
     *d = time;
     QueueMessage(m_hWnd, UWM_PLOTTIME, (WPARAM)d, (LPARAM)nthreads);
     
    } // CopenmpDlg::ShowElapsedTime

/****************************************************************************
*                         CopenmpDlg::OnGetMinMaxInfo
* Inputs:
*       MINMAXINFO * lpMMI:
* Result: void
*       
* Effect: 
*       Limits the dynamic resizing
****************************************************************************/

void CopenmpDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
    {
     if(c_Frame.GetSafeHwnd() != NULL)
        { /* can limit */
         CRect r;
         c_Frame.GetWindowRect(&r);
         ScreenToClient(&r);
         CalcWindowRect(&r);
         lpMMI->ptMinTrackSize.x = r.Width();
         lpMMI->ptMinTrackSize.y = r.Height();
         return;
        } /* can limit */

     CDialog::OnGetMinMaxInfo(lpMMI);
    }
