// openmpDlg.h : header file
//

#pragma once
#include "resource.h"
#include "MultiProgressBar.h"
#include "Plot.h"

// CopenmpDlg dialog
class CopenmpDlg : public CDialog
{
// Construction
public:
        CopenmpDlg(CWnd* pParent = NULL);       // standard constructor

// Dialog Data
        enum { IDD = IDD_OPENMP_DIALOG };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support


// Implementation
protected:
        HICON m_hIcon;

        // Generated message map functions
        virtual BOOL OnInitDialog();
        afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
        afx_msg void OnPaint();
        afx_msg HCURSOR OnQueryDragIcon();
        DECLARE_MESSAGE_MAP()
    virtual void OnOK();
    virtual void OnCancel();
    afx_msg void OnClose();
//
    afx_msg void OnBnClickedRun();
    afx_msg void OnBnClickedScheduleStatic();
    afx_msg void OnBnClickedScheduleDynamic();
    afx_msg void OnBnClickedScheduleGuided();
    afx_msg void OnBnClickedScheduleRuntime();
    afx_msg void OnBnClickedUseChunk();
    afx_msg void OnEnChangeChunk();
    afx_msg void OnEnChangeEnvironment();
    afx_msg LRESULT OnSetRange(WPARAM, LPARAM);
    afx_msg LRESULT OnThreadInfo(WPARAM, LPARAM);
    afx_msg LRESULT OnThreadFinished(WPARAM, LPARAM);
    afx_msg LRESULT OnThreadCount(WPARAM wParam, LPARAM);
    afx_msg LRESULT OnTime(WPARAM, LPARAM);
    afx_msg LRESULT OnRunUntil(WPARAM, LPARAM);
    afx_msg void OnBnClickedompsetnumthreads();
    afx_msg void OnBnClickedCopy();
    afx_msg void OnSize(UINT, int, int);
    void updateControls();
    void DoSomething(int i);
    void QueueMessage(HWND hWnd, UINT message, WPARAM = 0, LPARAM = 0);
    afx_msg LRESULT OnKickIdle(WPARAM, LPARAM);
    afx_msg LRESULT OnTimePlot(WPARAM, LPARAM);
    afx_msg void OnEnChangeThreads();
    afx_msg void OnBnClickedCleartimes();
    afx_msg void OnBnClickedAtomicPlus();
    afx_msg void OnBnClickedAtomicMultiply();
    afx_msg void OnBnClickedSections();
    afx_msg LRESULT OnTick(WPARAM, LPARAM);
    afx_msg void OnBnClickedParallelForEnable();
    afx_msg void OnBnClickedAtomicTestsEnable();
    afx_msg void OnBnClickedParallelSectionsEnable();
    afx_msg void OnBnClickedNowait();
    afx_msg void OnBnClickedCopyGraph();
    afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
//
protected:
    CStatic c_Frame;
    //****************************************************************
    // Selection
    //****************************************************************
    CButton c_ParallelForEnable;
    CButton c_AtomicTestsEnable;
    CButton c_ParallelSectionsEnable;
    //****************************************************************
    // General Setup
    //****************************************************************
    CStatic c_Ten;
    CEdit c_Work;
    CSpinButtonCtrl c_SpinWork;
    CButton c_ClearTimes;
    CButton c_omp_set_dynamic;
    CButton c_GUIHiPri;
    CEdit c_Time;
    CEdit c_NumThreads;
    CButton c_omp_set_num_threads;
    CStatic c_omp_set_num_threads_paren;
    CSpinButtonCtrl c_SpinNumThreads;
    CEdit c_CPUs;
    CButton c_RunUntil;
    CStatic c_RunUntilCount;

    //****************************************************************
    // Display
    //****************************************************************
    CMultiProgressBar c_Progress;
    CEdit c_Code;
    CPlot c_Plot;
    CButton c_CopyGraph;
    CButton c_CopyCode;
    //****************************************************************
    // Parallel For
    //****************************************************************
    CButton x_ParallelFor;
    CButton c_Run;
    CButton c_ScheduleStatic;
    CButton c_ScheduleDynamic;
    CButton c_ScheduleGuided;
    CButton c_ScheduleRuntime;
    CSpinButtonCtrl c_SpinChunk;
    CButton c_UseChunk;
    CEdit c_Chunk;
    CEdit c_Environment;
    CEdit x_Environment;
    CStatic c_GetEnv;
    //****************************************************************
    // Atomic tests
    //****************************************************************
    CButton x_AtomicTests;
    CButton c_AtomicAdd;
    CButton c_AtomicMul;
    //****************************************************************
    // Parallel Sections
    //****************************************************************
    CButton x_ParallelSections;
    CButton c_Sections;
    CButton c_NoWait;
    CButton c_Spin;
    CButton c_Sleep;
protected: // variables
     BOOL initialized;
     BOOL running;
     HANDLE queue;
     CArray<LARGE_INTEGER, LARGE_INTEGER> times;
     int work;
protected: // methods
     void DoNothing(int i);
     void WasteTime(int i);
     void ThreadPrep();
     void ShowDuration(LARGE_INTEGER duration);
     int InitOMPParameters();
     void ShowElapsedTime(LARGE_INTEGER duration, int nthreads);

//****************************************************************
// Atomic tests
//****************************************************************
protected: //
   int testvalue;
   int testoperand;

//****************************************************************
// thread parameters
//****************************************************************
protected:
     int defaultthreads;
     int numthreads;
     BOOL UseNumThreads;
     BOOL setdynamic;
     BOOL RunUntil;

//****************************************************************
// parallel for
//****************************************************************
protected:
   static UINT parallelfor(LPVOID p);
   void parallelfor();
   void DoForAllLoop(int nthreads);
   
//****************************************************************
// sections 
//****************************************************************
protected:
     static UINT sections(LPVOID p);
     void sections();
     int delay;
     DWORD startTime;
     UINT WaitType;

     BOOL NoWait;
     void DoSections(const int delay);
     void DoSectionsNoWait(const int delay);
     void DoSectionLoop(int nthreads);

     void DoTick(const int section, const int threadno, const int delay, const int count);
     void MarkTime(int section, int threadno);
};
