#include "stdafx.h"
#include <omp.h>


/****************************************************************************
*                               AtomicIncrement
* Inputs:
*       int & p:
* Result: void
*       
* Effect: 
*       Increments atomically
****************************************************************************/

void AtomicIncrement(int & p)
    {
#pragma omp atomic
     p++;
    } // AtomicIncrement

/****************************************************************************
*                               AtomicDecrement
* Inputs:
*       int & p:
* Result: void
*       
* Effect: 
*       Decrements the value
****************************************************************************/

void AtomicDecrement(int & p)
    {
#pragma omp atomic
     p--;
    } // AtomicDecrement

/****************************************************************************
*                                  AtomicAnd
* Inputs:
*       int * p: Value to and with
*       int a: Andend
* Result: void
*       
* Effect: 
*       Ands with the value
****************************************************************************/

void AtomicAnd(int & p, int a)
    {
#pragma omp atomic
     p &= a;
    } // AtomicAnd
